<?php
/*
Author: Miguel dos Santos(Modifications: Michael Champanis <michael.champanis@gmail.com>)
Author URI: http://www.webaddict.co.za
Description: Administrative options for Community Cloud
Version: 2.0
*/

require_once('includes/common.php');

if($write_flag = is_writable(ABSPATH)) $write_path = ABSPATH.'/hcard-social.html';
elseif($write_flag = is_writable(ABSPATH.$community_cloud_path.'/services')) $write_path = ABSPATH.$community_cloud_path.'/services/hcard-social.html';

// check form submission and update options
if ('process' == $_POST['stage']) {
	
	$old_excluded_authors = stripslashes(get_option('cc_exclude_email'));
	$old_exclude_urls = stripslashes(get_option('cc_exclude_url'));
	$old_empty_urls = stripslashes(get_option('cc_empty_urls'));
	$old_threshold = stripslashes(get_option('cc_threshold'));
	
	// update cloud definition options
	update_option('cc_exclude_email', $_POST['cc_exclude_email']);
	update_option('cc_exclude_url', $_POST['cc_exclude_url']);
	update_option('cc_empty_urls', $_POST['cc_empty_urls']);
	update_option('cc_threshold', $_POST['cc_threshold']);
	// if any of these things change, we need to rebuild the contents of the community cloud table
	if( $_POST['cc_exclude_email'] != $old_excluded_authors ||
			$_POST['cc_exclude_url'] != $old_exclude_urls ||
			$_POST['cc_empty_urls'] != $old_empty_urls ||
			$_POST['cc_threshold'] != $old_threshold ) {
		// empty the table 
		$results = $wpdb->query("TRUNCATE TABLE `".$community_cloud_table_name."`;");
		update_option('cc_position', 0);
		// repopulate community cloud table
		community_cloud_build_cloud();
	}
	
	//update cloud display options
	update_option('cc_maxtagsize', $_POST['cc_maxtagsize']);
	update_option('cc_mintagsize', $_POST['cc_mintagsize']);
	update_option('cc_fontunits', $_POST['cc_fontunits']);
	update_option('cc_maxtagcolour', $_POST['cc_maxtagcolour']);
	update_option('cc_mintagcolour', $_POST['cc_mintagcolour']);
	update_option('cc_show_comment_count', $_POST['cc_show_comment_count']);
	update_option('cc_seperator', $_POST['cc_seperator']);
	update_option('cc_order_by', $_POST['cc_order_by']);
	
  // update social options  
	$author_name = htmlentities(strip_tags($_POST['cc_author_name']));
	$friendfeed = htmlentities(strip_tags($_POST['cc_social_friendfeed']));
	$twitter = htmlentities(strip_tags($_POST['cc_social_twitter']));
	$facebook = htmlentities(strip_tags($_POST['cc_social_facebook']));
	$hcard = htmlentities($_POST['cc_social_hcard']);
	update_option('cc_creator_credit', $_POST['cc_creator_credit']);
	update_option('cc_author_name', $author_name);
	update_option('cc_social_friendfeed', $friendfeed);
	update_option('cc_social_twitter', $twitter);
	update_option('cc_social_facebook', $facebook);
	update_option('cc_advanced_hcard', $_POST['cc_advanced_hcard']);
	//write social hcard
	
	if($write_flag) {
		$f = fopen($write_path, 'w+');
		if ($f) {
			if(!$_POST['cc_advanced_hcard']) {
				$blog_url = get_option('siteurl');
				$hcard =<<<HCARD
<div id="hcard-$author_name" class="vcard">
	  <span class="fn n">
	   <span class="given-name">$author_name</span>
	  </span>  
	  <span class="url">
	   <a class="blog" href="$blog_url">$blog_url</a>
	   <a class="friendfeed" href="$friendfeed">$friendfeed</a>
	   <a class="twitter" href="$twitter">$twitter</a>
	   <a class="facebook" href="$facebook">$facebook</a>   
	  </span>
</div>
HCARD;
			}
	    fwrite($f, $hcard);
	    fclose($f);
	  }
	}
	update_option('cc_social_hcard', $hcard);
}

// Get options for form fields
$cc_exclude_email = stripslashes(get_option('cc_exclude_email'));
$cc_exclude_url = get_option('cc_exclude_url');
$cc_empty_urls = get_option('cc_empty_urls');
$cc_threshold = stripslashes(get_option('cc_threshold'));
$cc_maxtagsize = stripslashes(get_option('cc_maxtagsize'));
$cc_mintagsize = stripslashes(get_option('cc_mintagsize'));
$cc_fontunits = stripslashes(get_option('cc_fontunits'));
$cc_maxtagcolour = stripslashes(get_option('cc_maxtagcolour'));
$cc_mintagcolour = stripslashes(get_option('cc_mintagcolour'));
$cc_show_comment_count = get_option('cc_show_comment_count');
$cc_seperator = get_option('cc_seperator');
$cc_order_by = get_option('cc_order_by');
// get social options
$cc_creator_credit = get_option('cc_creator_credit');
$cc_author_name = stripslashes(get_option('cc_author_name'));
$cc_social_friendfeed = stripslashes(get_option('cc_social_friendfeed'));
$cc_social_twitter = stripslashes(get_option('cc_social_twitter'));
$cc_social_facebook = stripslashes(get_option('cc_social_facebook'));
$cc_advanced_hcard = get_option('cc_advanced_hcard');
$cc_social_hcard = html_entity_decode(stripslashes(get_option('cc_social_hcard')));

?>

<div class="wrap">
	<h2><?php _e('Community Cloud Options', 'cc') ?></h2>
  <form name="form1" method="post" action="<?php echo $community_cloud_location ?>&amp;updated=true">
		<input type="hidden" name="stage" value="process" />
		<p><?php _e('Please configure your community cloud below', 'cc') ?></p>
		<fieldset><legend style='font-size:1.4em'><?php _e('Cloud Definition', 'cc') ?></legend>
		<p><?php _e('Configure what appears in the cloud.', 'cc') ?></p>
    <table width="100%" cellspacing="2" cellpadding="5" class="editform">
      <tr valign="top">
				<th scope="row" width="25%" align="right"><p><?php _e('Exclude Commenter Emails: ', 'cc') ?></p></th>
        <td><p><textarea name="cc_exclude_email" rows='3' cols='60' id="cc_exclude_email"><?php echo $cc_exclude_email; ?></textarea>
        <br />
				<?php _e('Comma-delimited list of commenter emails you want to exclude from your community cloud. <br />Usually blog authors emails, as they are often the most frequent commenters.', 'cc') ?></p></td>
      </tr>
			<tr valign="top">
				<th scope="row" align="right"><p><?php _e('Exclude Commenter URLs: ', 'cc') ?></p></th>
        <td><p><input name="cc_exclude_url" id="cc_exclude_url" value="<?php echo $cc_exclude_url; ?>" size='60' />
        <br />
				<?php _e("Comma-delimited list of commenter urls you want to exclude from your community cloud. Sometimes people enter your own blog url as theirs, this will cause your social hCard to appear on their name in your cloud.", 'cc') ?></p></td>
      </tr>
			<tr valign="top">
				<th scope="row" align="right"><p><?php _e("Include Empty URL's: ", 'cc') ?></p></th>
        <td><p><input name="cc_empty_urls" type="checkbox" id="cc_empty_urls" value="1"<?php if($cc_empty_urls==1) echo " checked='checked'"; ?> />
				<?php _e("Include/Exclude commenters who haven't entered a blog/website URL with their comment.", 'cc') ?></p></td>
      </tr>
			<tr valign="top">
				<th scope="row" align="right"><p><?php _e('Commenter Threshold: ', 'cc') ?></p></th>
        <td><p><input name="cc_threshold" type="text" id="cc_threshold" value="<?php echo $cc_threshold; ?>" size="5" />
        <br />
				<?php _e("Enter the number of comments a person must post before they appear in the cloud.", 'cc') ?></p></td>
      </tr>
		</table>
		</fieldset>
		<br />
		<fieldset><legend style='font-size:1.4em'><?php _e('Cloud Display', 'cc') ?></legend>
		<p><?php _e('Configure how the cloud is displayed.', 'cc') ?></p>
		<table width="100%" cellspacing="2" cellpadding="5" class="editform">
      <tr valign="top">
				<th scope="row" width="25%" align="right"><p><?php _e('Maximum Font Size: ', 'cc') ?></p></th>
        <td><p><input name="cc_maxtagsize" type="text" id="cc_maxtagsize" value="<?php echo $cc_maxtagsize; ?>" size="10" />
        <br />
				<?php _e('Enter the font size of the most popular commenter.', 'cc') ?></p></td>
      </tr>
		  <tr valign="top">
				<th scope="row" align="right"><p><?php _e('Minimum Font Size: ', 'cc') ?></p></th>
				<td><p><input name="cc_mintagsize" type="text" id="cc_mintagsize" value="<?php echo $cc_mintagsize; ?>" size="10" />
				<br />
				<?php _e('Enter the font size of the least popular commenter.', 'cc') ?></p></td>
		  </tr>
		  <tr valign="top">
				<th scope="row" align="right"><p><?php _e('Font Unit: ', 'cc') ?></p></th>
				<td><p><select name="cc_fontunits" type="text" id="cc_fontunits">
					<option value='%'<?php if($cc_fontunits=='%') echo " selected='selected'"; ?>>%</option>
					<option value='pt'<?php if($cc_fontunits=='pt') echo " selected='selected'"; ?>>pt</option>
					<option value='px'<?php if($cc_fontunits=='px') echo " selected='selected'"; ?>>px</option>
					<option value='em'<?php if($cc_fontunits=='em') echo " selected='selected'"; ?>>em</option>
				</select>
				<br />
				<?php _e('Enter the font size unit of each link.', 'cc') ?></p></td>
		  </tr>
			<tr valign="top">
				<th scope="row" align="right"><p><?php _e('Maximum Font Colour: ', 'cc') ?></p></th>
        <td><p><input name="cc_maxtagcolour" type="text" id="cc_maxtagcolour" value="<?php echo $cc_maxtagcolour; ?>" size="10" />
        <br />
				<?php _e('Enter the font colour of the most popular commenter. (if empty, your theme default is used)', 'cc') ?></p></td>
      </tr>
		  <tr valign="top">
				<th scope="row" align="right"><p><?php _e('Minimum Font Colour: ', 'cc') ?></p></th>
				<td><p><input name="cc_mintagcolour" type="text" id="cc_mintagcolour" value="<?php echo $cc_mintagcolour; ?>" size="10" />
				<br />
				<?php _e('Enter the font colour of the least popular commenter. (if empty, your theme default is used)', 'cc') ?></p></td>
		  </tr>
			<tr valign="top">
				<th scope="row" align="right"><p><?php _e('Link Seperator: ', 'cc') ?></p></th>
				<td><p><input name="cc_seperator" type="text" id="cc_seperator" value="<?php echo $cc_seperator; ?>" size="5" />
				<br />
				<?php _e('Enter the character that seperates each link in your community cloud.', 'cc') ?></p></td>
		  </tr>
			<tr valign="top">
				<th scope="row" align="right"><p><?php _e('Show Comment Count: ', 'cc') ?></p></th>
				<td><p><select name="cc_show_comment_count" type="text" id="cc_show_comment_count">
					<option value='none'<?php if($cc_show_comment_count=='none') echo " selected='selected'"; ?>>Don't show comment count</option>
					<option value='tooltip'<?php if($cc_show_comment_count=='tooltip') echo " selected='selected'"; ?>>Show comment count in tooltip text</option>
					<option value='link'<?php if($cc_show_comment_count=='link') echo " selected='selected'"; ?>>Show comment count inside link after the author's name</option>
				</select>
        <br />
				<?php _e('Show the number of comments each author has written, eg. John (5), either in the link tooltip text, in the link itself, or not at all.', 'cc') ?></p></td>
      </tr>
			<tr valign="top">
				<th scope="row" align="right"><p><?php _e('Order Commenters By: ', 'cc') ?></p></th>
				<td><p><select name="cc_order_by" type="text" id="cc_order_by">
					<option value='random'<?php if($cc_order_by=='random') echo " selected='selected'"; ?>>Random</option>
					<option value='recent'<?php if($cc_order_by=='recent') echo " selected='selected'"; ?>>Recent Commenter -> Earliest Commenter</option>
					<option value='top'<?php if($cc_order_by=='top') echo " selected='selected'"; ?>>Top Commenter -> Lowest Commenter</option>
				</select>
				<br />
				<?php _e('Select the order in which the cloud will display', 'cc') ?></p></td>
		  </tr>
		</table>
		</fieldset>
		<br />
		<fieldset><legend style='font-size:1.4em'><?php _e('Cloud Social', 'cc') ?></legend>
		<p><?php _e('Configure your social settings.', 'cc') ?></p>
		<table width="100%" cellspacing="2" cellpadding="5" class="editform">
			<tr valign="top">
				<th scope="row" width="25%" align="right"><p><?php _e('Share this plugin: ', 'cc') ?></p></th>
				<td><p><input name="cc_creator_credit" type="checkbox" id="cc_creator_credit" value="1"<?php if($cc_creator_credit==1) echo " checked='checked'"; ?> />
				<?php _e('Help spread the word, share this plugin. <br />If checked, your community cloud will include a link back to this plugin download page.', 'cc') ?></p></td>
		  </tr>
		</table>
		
		<?php if($write_flag) { ?>
			<table width="100%" cellspacing="2" cellpadding="5" class="editform">
				<tr valign="top">
					<th scope="row" align="right" width="25%"><p><?php _e('Advanced hCard: ', 'cc') ?></p></th>
					<td><p><input name="cc_advanced_hcard" type="checkbox" id="cc_advanced_hcard" onclick="$('simple_hcard').toggle();$('advanced_hcard').toggle();" value="1"<?php if($cc_advanced_hcard==1) echo " checked='checked'"; ?> />
					<?php _e('Ticking this box allows you to enter your own customised hCard.', 'cc') ?></p></td>
			  </tr>
			</table>
			<table width="100%" cellspacing="2" cellpadding="5" class="editform" id='simple_hcard'<?php if($cc_advanced_hcard==1) echo " style='display:none;'"; ?>>
				<tr valign="top" id='simple_author'>
					<th scope="row" width="25%"></th>
	        <td style='font-size:1.1em;'><p><?php _e('Your social hCard will be automatically created for you from the details below.', 'cc') ?></p></td>
	      </tr>
				<tr valign="top" id='simple_author'>
					<th scope="row" align="right"><p><?php _e('Author Name: ', 'cc') ?></p></th>
	        <td><p><input name="cc_author_name" type="text" id="cc_author_name" value="<?php echo $cc_author_name; ?>" size="60" />
	        <br />
					<?php _e('Your Name', 'cc') ?></p></td>
	      </tr>
	      <tr valign="top" id='simple_friendfeed'>
					<th scope="row" align="right"><p><?php _e('FriendFeed URL: ', 'cc') ?></p></th>
	        <td><p><input name="cc_social_friendfeed" type="text" id="cc_social_friendfeed" value="<?php echo $cc_social_friendfeed; ?>" size="60" />
	        <br />
					<?php _e('Your FriendFeed URL', 'cc') ?></p></td>
	      </tr>
	      <tr valign="top" id='simple_twitter'>
					<th scope="row" align="right"><p><?php _e('Twitter URL: ', 'cc') ?></p></th>
	        <td><p><input name="cc_social_twitter" type="text" id="cc_social_twitter" value="<?php echo $cc_social_twitter; ?>" size="60" />
	        <br />
					<?php _e('Your Twitter URL', 'cc') ?></p></td>
	      </tr>
	      <tr valign="top" id='simple_facebook'>
					<th scope="row" align="right"><p><?php _e('Facebook profile URL: ', 'cc') ?></p></th>
	        <td><p><input name="cc_social_facebook" type="text" id="cc_social_facebook" value="<?php echo $cc_social_facebook; ?>" size="60" />
	        <br />
					<?php _e('Your Facebook Profile URL', 'cc') ?></p></td>
	      </tr>
			</table>
			<table width="100%" cellspacing="2" cellpadding="5" class="editform">
				<tr valign="top" id='advanced_hcard'<?php if($cc_advanced_hcard==0) echo " style='display:none;'"; ?>>
					<th scope="row" width="25%" align="right"></th>
					<td><p><?php _e('Enter your custom hCard in the textarea below. To find our more about hCard, <a href="http://microformats.org/wiki/hcard" title="hCard">click here</a><br />', 'cc') ?></p>
					<textarea rows="6" cols="60" name="cc_social_hcard" id="cc_social_hcard"><?php echo $cc_social_hcard; ?></textarea></td>
			  </tr>
	    </table>
			
		<?php } else { ?>
			<p>
			<table width="100%" cellspacing="2" cellpadding="5" class="editform">
				<tr valign="top">
					<th scope="row" width="25%" align="right"><?php _e('Your Social hCard: <p class="wrap updated" style="font-weight: normal;">warning: directory not writable</p>', 'cc') ?></th>
					<td><?php _e('If your community cloud plugin directory, or even your root directory were <a href="http://codex.wordpress.org/Changing_File_Permissions">writable</a>, 
					we would be able to automatically create and update your social hCard for you, but it isn\'t, so here is a template you can use to create your own.
					<p>Please copy and paste the contents of the textarea below into a file named <nobr><b>hcard-social.html</b></nobr> and put it either in your community cloud plugin directory <nobr>(<b>'.$community_cloud_path.'</b>)</nobr>,
					or <em>even better</em> in your blog\'s root directory.</p>', 'cc') ?>
					<textarea rows="6" cols="60" name="cc_social_hcard" id="cc_social_hcard"><?php echo $cc_social_hcard; ?></textarea>
					<?php _e('<br /><br />To find our more about hCard\'s, <a href="http://microformats.org/wiki/hcard" title="hCard">click here</a>', 'cc') ?></td>
			  </tr>
	    </table>
			</p>
		<?php } ?>
		
		</fieldset>
		<p>
		<table border="0" cellpadding="5" width='60%' align="right"><tr>
			<th scope="row" align="center">Step 1</th>
			<th scope="row" align="left">&nbsp;&nbsp;&nbsp;&nbsp;Step 2</th>
		</tr><tr valign="top">
			<td class='submit' align='center'>
				<input type="submit" name="Submit" value="<?php _e('Update Options', 'cc') ?> &raquo;" />
			</td><td class='submit' align='left'>
				<input type="button" value="Update Community Cloud hCards" onclick="community_cloud_ajax_get_hcard('hcard-spinner','hcard-result');" /><br />
				<span id='hcard-spinner' style='display:none;'>&nbsp;&nbsp;&nbsp;&nbsp;<img src='<?php echo get_option('siteurl').$community_cloud_path; ?>/images/wait.gif' alt='loading...' /></span>
				<span id='hcard-result'><p>&nbsp;&nbsp;&nbsp;&nbsp;<em>warning: this may take a while</em></p></span>
			</td>
		</tr></table>
		</p>
  </form>
	<br />
</div>
