<?php
	
	$community_cloud_table_name = $wpdb->prefix."community_cloud";
	$community_cloud_remote_path = "/wp-content/plugins/community_cloud/services";
	$community_cloud_plugin_basepath = str_replace("/includes/common.php", "", plugin_basename(__FILE__));
	$community_cloud_location = get_option('siteurl').'/wp-admin/admin.php?page='.$community_cloud_plugin_basepath.'/community_cloud-options.php'; // Form Action URI
	load_plugin_textdomain('cc',$community_cloud_path = '/wp-content/plugins/'.$community_cloud_plugin_basepath);
	
	/* (re)Build the community cloud table */
	function community_cloud_build_cloud($comment_id = false) {
		global $wpdb;
		//need to redclare thes because of global var issue when plugin is activated (http://wordpress.org/support/topic/201309)
		$community_cloud_table_name = $wpdb->prefix."community_cloud";
  	$community_cloud_remote_path = "/wp-content/plugins/community_cloud/services";
		
		$exclude_author = explode(',', get_option('cc_exclude_email'));
		$include_empty_urls = get_option('cc_empty_urls');
		
		//rebuild community cloud only for the comment author of comment id parsed
		if($comment_id) {
			
			$request = "SELECT DISTINCT * FROM ".$wpdb->comments." WHERE comment_ID = ".$comment_id."";
			if(!$include_empty_urls) $request .= " AND c.comment_author_url <> '' AND c.comment_author_url <> ' ' AND c.comment_author_url <> 'http://'";
			foreach($exclude_author as $e) { $request .= " AND c.comment_author_email <> '".trim($e)."'"; }
			$request .= " AND p.post_password ='' AND c.comment_approved = '1'";
			$comments = $wpdb->get_results($request);
			
			foreach ($comments as $comment) {
				//valid updated url and set hcard url
				$hcard = '';
				if($link_flag = community_cloud_valid_url($comment->comment_author_url)) {
					//pre-check if hcard exists
					$temp_author_url = parse_url($comment->comment_author_url);
					$real_author_url = $temp_author_url['scheme'].'://'.$temp_author_url['host'];
					if (community_cloud_url_exists($real_author_url."/hcard-social.html")) $hcard = $real_author_url."/hcard-social.html";
					elseif (community_cloud_url_exists($real_author_url.$community_cloud_remote_path."/hcard-social.html")) $hcard = $real_author_url.$community_cloud_remote_path."/hcard-social.html";
					if(!community_cloud_hcard_exists($hcard)) $hcard = '';
				}
				//count comments from this author in comments table
				$count_result = $wpdb->get_results("SELECT count(*) as counter FROM ".$wpdb->comments." as c WHERE c.comment_author_email = '".mysql_escape_string($comment->comment_author_email)."' AND c.comment_approved = '1';");
				//and check if their authors have an entry in the community cloud
				if($cloud = $wpdb->get_row("SELECT * FROM `".$community_cloud_table_name."` WHERE email = '".$comment->comment_author_email."'", ARRAY_A)) {
					//update this comment cloud table with latest info
					$wpdb->query('UPDATE '.$community_cloud_table_name.' SET count = '.$count_result[0]->counter.', last_comment_date = '.strtotime($comment->comment_date).', url = "'.$comment->comment_author_url.'", hcard_urls = "'.$hcard.'" WHERE id = "'.$cloud['id'].'"');
				} else {
					//insert new commenter into community cloud table
					$wpdb->query("INSERT INTO `" . $community_cloud_table_name . "` (`name`, `url`, `last_comment_date`, `count`, `hcard_url`) VALUES ('".$comment->comment_author."','".(($link_flag)?$comment->comment_author_url:'')."', ".strtotime($comment->comment_date).", ".$count_result[0]->counter.", '".$hcard."');");
				}
			}
			
		} else { //build community cloud for all unique commenters in the comments table
			
			// get all unique commenter names
			$request = "SELECT DISTINCT c.comment_author_email FROM ".$wpdb->comments." as c LEFT JOIN ".$wpdb->posts." as p ON p.ID=c.comment_post_ID WHERE p.post_status = 'publish' AND c.comment_type <> 'trackback' AND c.comment_type <> 'pingback' AND c.comment_approved = '1' AND c.comment_author_email <> ''";
			if(!$include_empty_urls) $request .= " AND c.comment_author_url <> '' AND c.comment_author_url <> 'http://'";
			foreach($exclude_author as $e) $request .= " AND LOWER(c.comment_author_email) <> '".strtolower(trim($e))."'";
			
			$comments = $wpdb->get_results($request);
			foreach ($comments as $comment) {
				
				// count the number of comments from this person
				$count_result = $wpdb->get_results(
					"SELECT count(*) as counter FROM ".$wpdb->comments." as c 
					WHERE c.comment_author_email = '".mysql_escape_string($comment->comment_author_email)."' 
					AND c.comment_approved = '1';"
				);
				if($count_result[0]->counter >= get_option('cc_threshold')) {
					
					//get commenter URL, date/time their last comment was made
					$comment_author = $wpdb->get_results(
						"SELECT c.comment_author, c.comment_author_url, c.comment_date FROM ".$wpdb->comments." as c " .
						"WHERE c.comment_author_email = '".mysql_escape_string($comment->comment_author_email)."' " .
						"AND c.comment_approved = '1' ORDER BY c.comment_ID DESC LIMIT 0, 1;"
					);
					
					$link_flag = community_cloud_valid_url($comment_author[0]->comment_author_url);
					// insert compiled data for this commenter into community cloud table
					if(($link_flag && get_option('cc_empty_urls')==0) || get_option('cc_empty_urls')==1) {
						$wpdb->query("INSERT INTO `" . $community_cloud_table_name . "` (`name`, `url`, `last_comment_date`, `count`, `hcard_url`) " .
							"VALUES ('".$comment_author[0]->comment_author."','".(($link_flag)?$comment_author[0]->comment_author_url:'')."', " .
							strtotime($comment_author[0]->comment_date).", ".$count_result[0]->counter.", '')");
					}
				}
			}
		}
	}
	
	//check that url is valid and well formed
	function community_cloud_valid_url( $url ) {
		if(@substr_count(get_option('cc_exclude_url'), $url)) return false;
		else return preg_match('/^(http|https|ftp):\/\/([A-Z0-9][A-Z0-9_-]*(?:\.[A-Z0-9][A-Z0-9_-]*)+):?(\d+)?\/?/i', $url);
		//return preg_match('/^(([\w]+:)?\/\/)?(([\d\w]|%[a-fA-f\d]{2,2})+(:([\d\w]|%[a-fA-f\d]{2,2})+)?@)?([\d\w][-\d\w]{0,253}[\d\w]\.)+[\w]{2,4}(:[\d]+)?(\/([-+_~.\d\w]|%[a-fA-f\d]{2,2})*)*(\?(&amp;?([-+_~.\d\w]|%[a-fA-f\d]{2,2})=?)*)?(#([-+_~.\d\w]|%[a-fA-f\d]{2,2})*)?$/', $url);
	}
	
	//checks that the url  returns a 200 OK status
	function community_cloud_url_exists($url) {
		$headers = wp_get_http($url);
		if($headers['response']=='200' && $headers['x-final-location']==$url) return true;
		else return false;
	}
	function community_cloud_get_hcard($url) {
		return unserialize(wp_remote_fopen('http://tools.microformatic.com/query/php/hkit/'.$url));
	}
	function community_cloud_hcard_exists($url) {
		$hcard = community_cloud_get_hcard($url);
		if( is_array($hcard) && count($hcard) > 0) return true;
		else return false;
	}
	
	function community_cloud_GetFontSizeForWeight($weight) {
		$maxtagsize = (get_option('cc_maxtagsize'))?get_option('cc_maxtagsize'):500;
		$mintagsize = (get_option('cc_mintagsize'))?get_option('cc_mintagsize'):90;
		$fontunits = (get_option('cc_fontunits'))?get_option('cc_fontunits'):'%';
		if ($maxtagsize > $mintagsize) $fontsize = (($weight/100) * ($maxtagsize - $mintagsize)) + $mintagsize;
		else $fontsize = (((100-$weight)/100) * ($maxtagsize - $mintagsize)) + $maxtagsize;
		return intval($fontsize) . $fontunits;
	}

	function community_cloud_GetColorForWeight($weight) {
		if(!get_option('cc_maxtagcolour') && !get_option('cc_mintagcolour')) return "";
		$maxtagcolour = get_option('cc_maxtagcolour');
		$mintagcolour = get_option('cc_mintagcolour');
		if ($weight) {
			$weight = $weight/100;
			
			$minr = hexdec(substr($mintagcolour, 1, 2));
			$ming = hexdec(substr($mintagcolour, 3, 2));
			$minb = hexdec(substr($mintagcolour, 5, 2));
			
			$maxr = hexdec(substr($maxtagcolour, 1, 2));
			$maxg = hexdec(substr($maxtagcolour, 3, 2));
			$maxb = hexdec(substr($maxtagcolour, 5, 2));
			
			$r = dechex(intval((($maxr - $minr) * $weight) + $minr));
			$g = dechex(intval((($maxg - $ming) * $weight) + $ming));
			$b = dechex(intval((($maxb - $minb) * $weight) + $minb));
			
			if (strlen($r) == 1) $r = "0" . $r;
			if (strlen($g) == 1) $g = "0" . $g;
			if (strlen($b) == 1) $b = "0" . $b;
			
			return "color:#$r$g$b";
		}
	}
	
	
	// add ajax script to handle retrieving of hCards
	add_action('admin_print_scripts', 'community_cloud_js_admin_header');
	
	function community_cloud_js_admin_header() {
	  wp_print_scripts( array( 'sack' ));
	?>
		<script type="text/javascript">//<![CDATA[
		function community_cloud_ajax_get_hcard( spinner, result ) {
		  var mysack = new sack( "<?php bloginfo('wpurl'); ?>/wp-admin/admin-ajax.php" );
		  mysack.execute = 1;
		  mysack.method = 'POST';
		  mysack.setVar( "action", "community_cloud_ajax_get_hcard_lookup" );
			mysack.setVar( "result", result );
		  mysack.encVar( "cookie", document.cookie, false );
			mysack.onLoading = function() { document.getElementById(spinner).style.display = 'block'; };
			mysack.onCompletion = function() { document.getElementById(spinner).style.display = 'none'; };
		  mysack.onError = function() { document.getElementById(result).innerHTML = 'Ajax error getting hCards'; document.getElementById(spinner).style.display = 'none'; };
		  mysack.runAJAX();
		  return true;
		} 
		//]]>
		</script>
	<?php
	}

	add_action('wp_ajax_community_cloud_ajax_get_hcard_lookup', 'community_cloud_ajax_get_hcard_lookup' );
	function community_cloud_ajax_get_hcard_lookup() {
		global $wpdb, $community_cloud_table_name, $community_cloud_remote_path;
		// read submitted information
		$field_id = $_POST['result'];
		$position = get_option('cc_position');
		if($position >= 0) {
			$counter = 0;
			
			//loop through community cloud table checking each url for hCard
			$comments = $wpdb->get_results("SELECT * FROM ".$community_cloud_table_name." ORDER BY `id` ASC");
			$total = count($comments);
			$comments = array_slice($comments,$position,70);
			foreach ($comments as $comment) {
				if($comment->url!='') {
					$flag = false;
					$temp_author_url = parse_url($comment->url);
					$real_author_url = $temp_author_url['scheme'].'://'.$temp_author_url['host'];
					$check_url = array($real_author_url."/hcard-social.html", $real_author_url.$community_cloud_remote_path."/hcard-social.html");
					foreach($check_url as $url) {
						if(!$flag && community_cloud_hcard_exists($url)) {
							//  update row with hcard url if we manage to get something and what we get is valid.
							$wpdb->query("UPDATE ".$community_cloud_table_name." SET hcard_url = '".$url."' WHERE id = ".$comment->id.";");
							$flag = true;
						}
					}
					$counter++;
				}
			}
			$position += $counter;
			update_option('cc_position', (($position>=$total)?-1:$position));
			// Compose JavaScript for return
			die( "document.getElementById('".$field_id."').innerHTML = '<p>&nbsp;&nbsp;&nbsp;&nbsp;hCard Update: <b>".round(($position/$total)*100)."%</b> Complete.</p>';" );
		} else {
			die( "document.getElementById('".$field_id."').innerHTML = '<p>&nbsp;&nbsp;&nbsp;&nbsp;hCard Update: <b>100%</b> Complete.</p>';" );
		}
	  
	}
	
?>