<?php
  /*
   * Author: Michael Champanis <michael.champanis@gmail.com>
   *
   * Fetches and parses a remote hCard for display inside a popup
   * 
   * see: http://microformats.org/wiki/hcard
   **/

@require_once('../../../wp-config.php');

$hcard_url = urldecode($_GET['hcard']);

if (isset($hcard_url) && trim($hcard_url!='')) {
	
	if (phpversion() > 5) {
		require_once('includes/hkit.class.php');
		$hkit = new hKit();
		$hkit->tidy_mode = 'none';
		$result = $hkit->getByURL('hcard', $hcard_url);
		//prepare results
		foreach($result[0]['url'] as $h) {
			$hcard[] = array('url' => $h);
		}
	} else {
		$url = 'http://tools.microformatic.com/query/php/hkit/' . $hcard_url;
		$hcard = unserialize(wp_remote_fopen($url));
	}
	if(count($hcard) > 0) {
		print "<ul id='social-list'>";  
		foreach($hcard as $h) {
			print '<li>'.$h['fn'].'</li>';
			if (isset($h['url']) and !empty($h['url'])) {
				$hu = explode(' ',$h['url']);
				foreach($hu as $u) {
					// get favicon from google s2 service
					$img = 'http://www.google.com/s2/favicons?domain='.substr_replace($u,'',0,strpos($u,'/')+2);
					print '<li><img src="'.$img.'" alt=""><a href="'.$u.'" title="">'.$u.'</a></li>';
				}
			}
		}
		print "</ul>";
	}
} else {
	//what to display when commenter doesn't have hcard set, at the moment don;t display anything
	//print '<p>No social HCard set</p>';
}

?>